#ifndef _POINTSET_
#define _POINTSET_

#include <stdio.h>  
#include "mypoint.hpp" 
#include <LEDA/array.h>  

class pointset {
  private: 
    leda_array <mypoint *> input ; 
    int input_counter ;

  public: 

    pointset(int msize) {
	input.resize(msize) ;
        input_counter = 0 ; 
    }

    void clear(int msize) {
	input.resize(msize) ;
        input_counter = 0 ; 
    }

    void push( mypoint  *pnt ) {
        input[ input_counter++ ] = new mypoint( pnt );
    }

    void push( double  x, double  y ) {
        input[ input_counter++ ] =  new mypoint( x, y ) ;
    }

    mypoint * get( int  pos ) {
        return  input[ pos ] ;
    }

    int  size() {
        return input_counter;
    }

    void print() {
        int  count = size();
        for (int i=0; i < count ;i++) {
            get( i )->print() ;
            printf("\n"); 
        }     
    }

    void copyWithYTrans( pointset  *points, double  delta ) {
        clear(points->size()) ; 

        for  ( int  ind = 0; ind < points->size(); ind++ ) {
            mypoint  *pnt = points->get( ind );
            push( pnt->x(), pnt->y() + delta );
        }
    }

    void sortPoints() ;

    int verifySubset( pointset *invec, double eps ) ; 
}; 

#endif
