#include <iostream.h> 
#include "segment.hpp" 

int segment::aboveSegment(mypoint *in, mypoint *p1, mypoint *q1) {
  double div1 = (q1->y()-p1->y())/(q1->x()-p1->x()) ;
  double tmp = div1 * in->x() + (p1->y() - div1*p1->x()) ;
  if ( tmp < in->y()) return 0 ;
  return 1  ;
}

int segment::aboveSegment(mypoint *in) {
  double div1 = (q->y()-p->y())/(q->x()-p->x()) ;
  double tmp = div1 * in->x() + (p->y() - div1*p->x()) ;
  if ( tmp < in->y()) return 0 ;
  return  1 ;
}

int segment::intersectSegments(mypoint *p1, mypoint *p2, mypoint *p3, mypoint *p4, mypoint *out) {
	p1->sety(-p1->y()) ;
	p2->sety(-p2->y()) ;
	p3->sety(-p3->y()) ;
	p4->sety(-p4->y()) ;

	double m1 = (p2->y()-p1->y())/(p2->x()-p1->x()) ;
	double c1 = p2->y() - (m1*p2->x()) ;
	double m2 = (p4->y()-p3->y())/(p4->x()-p3->x()) ;
	double c2 = p4->y() - (m2*p4->x()) ;
    
	double interx = (c2-c1)/(m1-m2) ;
	double intery = m1*interx + c1 ;
	if ( (intery > p3->y() -2 && intery < p4->y() +2) || (intery > p4->y() -2 && intery < p3->y()+2) ) {
	}
	else {  
	    p1->sety(-p1->y()) ;
	    p2->sety(-p2->y()) ;
	    p3->sety(-p3->y()) ;
	    p4->sety(-p4->y()) ;	
	    return 0 ; 
	}
	p1->sety(-p1->y()) ;
	p2->sety(-p2->y()) ;
	p3->sety(-p3->y()) ;
	p4->sety(-p4->y()) ;	
	out->setx((int)interx) ;
	out->sety(-(int)intery) ;
	return 1 ;
}

int segment::intersectSegment(mypoint *p1, mypoint *p2, mypoint *p3, double eps) {
	mypoint *p4 = new mypoint(p3->x(), p3->y() + eps) ;
	p3->sety(p3->y()-eps) ;
	
	p1->sety(-p1->y()) ;
	p2->sety(-p2->y()) ;
	p3->sety(-p3->y()) ;
	p4->sety(-p4->y()) ;

	double m1 = (p2->y()-p1->y())/(p2->x()-p1->x()) ;
	double c1 = p2->y() - (m1*p2->x()) ;
	double inter = m1*p3->x() + c1 ;
	if ( (inter > p3->y() -2 && inter < p4->y() +2) || (inter > p4->y() -2 && inter < p3->y()+2) ) {
	}
	else {  
	    p1->sety(-p1->y()) ;
	    p2->sety(-p2->y()) ;
	    p3->sety(-p3->y()) ;
	    p4->sety(-p4->y()) ;	
	    p3->sety(p3->y()+eps) ;
	    return 0 ; 
	}
	p1->sety(-p1->y()) ;
	p2->sety(-p2->y()) ;
	p3->sety(-p3->y()) ;
	p4->sety(-p4->y()) ;	
	p3->sety(p3->y()+eps) ;
	return 1 ;
}

int segment::intersect(pointset *invec, int i, int j, int k, double eps) {
	double *p1 = new double[2] ; p1[0] = (invec->get(i)->x()) ;  p1[1] = (invec->get(i)->y()) ;
	double *p2 = new double[2] ; p2[0] = (invec->get(j)->x()) ;  p2[1] = (invec->get(j)->y()) ;
	double *p3 = new double[2] ; p3[0] = (invec->get(k)->x()) ;  p3[1] = (invec->get(k)->y()) ;
	double *p4 = new double[2] ;
	p4[0] = p3[0] ;
	p4[1] = p3[1] + eps ;
	p3[1] = p3[1] - eps ;
	p1[1] = -p1[1] ; p2[1] = -p2[1] ; p3[1] = -p3[1] ; p4[1] = -p4[1] ;

	double m1 = (p2[1]-p1[1])/(p2[0]-p1[0]) ;
	double c1 = p2[1] - (m1*p2[0]) ;
	double inter = m1*p3[0] + c1 ;
	if ( (inter > p3[1]-2 && inter < p4[1]+2) || (inter > p4[1]-2 && inter < p3[1]+2) ) {
	}
	else {  	
	    p1[1] = -p1[1] ; p2[1] = -p2[1] ; p3[1] = -p3[1] ; p4[1] = -p4[1] ;	
	    p3[1] = p3[1] + eps ;
	    return 0 ; 
	}
	p1[1] = -p1[1] ; p2[1] = -p2[1] ; p3[1] = -p3[1] ; p4[1] = -p4[1] ;	
	p3[1] += eps ;
	return 1 ;
}
